pcl::octree::PointCoding< PointT > Class Template Reference

PointCoding class More...

`#include <pcl/compression/point_coding.h>`

## Public Member Functions

| PointCoding ()
| Constructor. More...
virtual | ~PointCoding ()
| Empty class constructor. More...
void | setPrecision (float precision_arg)
| Define precision of point information. More...
float | getPrecision ()
| Retrieve precision of point information. More...
void | setPointCount (unsigned int pointCount_arg)
| Set amount of points within point cloud to be encoded and reserve memory. More...
void | initializeEncoding ()
| Initialize encoding of differential point. More...
void | initializeDecoding ()
| Initialize decoding of differential point. More...
std::vector< char > & | getDifferentialDataVector ()
| Get reference to vector containing differential color data. More...
void | encodePoints (const typename std::vector< int > &indexVector_arg, const double *referencePoint_arg, PointCloudConstPtr inputCloud_arg)
| Encode differential point information for a subset of points from point cloud. More...
void | decodePoints (PointCloudPtr outputCloud_arg, const double *referencePoint_arg, std::size_t beginIdx_arg, std::size_t endIdx_arg)
| Decode differential point information. More...

## Protected Attributes

PointCloudPtr | output_
| Pointer to output point cloud dataset. More...
std::vector< char > | pointDiffDataVector_
| Vector for storing differential point information. More...
std::vector< char >::const_iterator | pointDiffDataVectorIterator_
| Iterator on differential point information vector. More...
float | pointCompressionResolution_
| Precision of point coding. More...

## Detailed Description

### template<typename PointT>
class pcl::octree::PointCoding< PointT >

PointCoding class

Note
  This class encodes 8-bit differential point information for octree-based point cloud compression.
  typename: PointT: type of point used in pointcloud

Author
  Julius Kammerl (juliu.nosp@m.s@ka.nosp@m.mmerl.nosp@m..de)

Definition at line 59 of file point_coding.h.

## Constructor & Destructor Documentation

template<typename PointT>

pcl::octree::PointCoding< PointT >::PointCoding | ( |  | ) |

inline

Constructor.

Definition at line 68 of file point_coding.h.

template<typename PointT>

virtual pcl::octree::PointCoding< PointT >::~PointCoding | ( |  | ) |

inline virtual

Empty class constructor.

Definition at line 76 of file point_coding.h.

## Member Function Documentation

template<typename PointT>

void pcl::octree::PointCoding< PointT >::decodePoints | ( | PointCloudPtr | outputCloud_arg,
|  | const double * | referencePoint_arg,
|  | std::size_t | beginIdx_arg,
|  | std::size_t | endIdx_arg
| ) |  |

inline

Decode differential point information.

Parameters

  outputCloud_arg | output point cloud
  referencePoint_arg | coordinates of reference point
  beginIdx_arg | index indicating first point to be assiged with color information
  endIdx_arg | index indicating last point to be assiged with color information

Definition at line 169 of file point_coding.h.

template<typename PointT>

void pcl::octree::PointCoding< PointT >::encodePoints | ( | const typename std::vector< int > & | indexVector_arg,
|  | const double * | referencePoint_arg,
|  | PointCloudConstPtr | inputCloud_arg
| ) |  |

inline

Encode differential point information for a subset of points from point cloud.

Parameters

  indexVector_arg | indices defining a subset of points from points cloud
  referencePoint_arg | coordinates of reference point
  inputCloud_arg | input point cloud

Definition at line 134 of file point_coding.h.

template<typename PointT>

std::vector<char>& pcl::octree::PointCoding< PointT >::getDifferentialDataVector | ( |  | ) |

inline

Get reference to vector containing differential color data.

Definition at line 123 of file point_coding.h.

template<typename PointT>

float pcl::octree::PointCoding< PointT >::getPrecision | ( |  | ) |

inline

Retrieve precision of point information.

Returns
  precision

Definition at line 93 of file point_coding.h.

template<typename PointT>

void pcl::octree::PointCoding< PointT >::initializeDecoding | ( |  | ) |

inline

Initialize decoding of differential point.

Definition at line 116 of file point_coding.h.

template<typename PointT>

void pcl::octree::PointCoding< PointT >::initializeEncoding | ( |  | ) |

inline

Initialize encoding of differential point.

Definition at line 109 of file point_coding.h.

template<typename PointT>

void pcl::octree::PointCoding< PointT >::setPointCount | ( | unsigned int | pointCount_arg | ) |

inline

Set amount of points within point cloud to be encoded and reserve memory.

Parameters

  pointCount_arg | amounts of points within point cloud

Definition at line 102 of file point_coding.h.

template<typename PointT>

void pcl::octree::PointCoding< PointT >::setPrecision | ( | float | precision_arg | ) |

inline

Define precision of point information.

Parameters

  precision_arg | precision

Definition at line 84 of file point_coding.h.

## Member Data Documentation

template<typename PointT>

PointCloudPtr pcl::octree::PointCoding< PointT >::output_

protected

Pointer to output point cloud dataset.

Definition at line 199 of file point_coding.h.

template<typename PointT>

float pcl::octree::PointCoding< PointT >::pointCompressionResolution_

protected

Precision of point coding.

Definition at line 208 of file point_coding.h.

Referenced by pcl::octree::PointCoding< pcl::PointXYZRGB >::decodePoints(), pcl::octree::PointCoding< pcl::PointXYZRGB >::encodePoints(), pcl::octree::PointCoding< pcl::PointXYZRGB >::getPrecision(), and pcl::octree::PointCoding< pcl::PointXYZRGB >::setPrecision().

template<typename PointT>

std::vector<char> pcl::octree::PointCoding< PointT >::pointDiffDataVector_

protected

Vector for storing differential point information.

Definition at line 202 of file point_coding.h.

Referenced by pcl::octree::PointCoding< pcl::PointXYZRGB >::encodePoints(), pcl::octree::PointCoding< pcl::PointXYZRGB >::getDifferentialDataVector(), pcl::octree::PointCoding< pcl::PointXYZRGB >::initializeDecoding(), pcl::octree::PointCoding< pcl::PointXYZRGB >::initializeEncoding(), and pcl::octree::PointCoding< pcl::PointXYZRGB >::setPointCount().

template<typename PointT>

std::vector<char>::const_iterator pcl::octree::PointCoding< PointT >::pointDiffDataVectorIterator_

protected

Iterator on differential point information vector.

Definition at line 205 of file point_coding.h.

Referenced by pcl::octree::PointCoding< pcl::PointXYZRGB >::decodePoints(), and pcl::octree::PointCoding< pcl::PointXYZRGB >::initializeDecoding().

The documentation for this class was generated from the following file:

- /build/pcl-0nnAvv/pcl-1.7.2/io/include/pcl/compression/point_coding.h